import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const

CustomPage {
    id: about_page

//    tools: BackToolBar{}

    TopSettingBack{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "关于"

        BackButton{
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}
        }
    }
    Image {
        id: about_image
        anchors{left: parent.left; top: top_bar.bottom}
        width: parent.width; height: parent.height - top_bar.height
        source: "images/about.png"
    }


    Rectangle{
        width: parent.width * 3 / 4; height: 80
        color: Const.Color.rectTrans
        Row{
            anchors.fill: parent
            Image{
                id: left_img
                width: 7; height: parent.height
                source: "images/button1_left.png"
            }

            Image {
                id: middle_img
                width: parent.width - left_img.width - right_img.width; height: parent.height
                source: "images/button1_mid.png"

            }
            Image{
                id: right_img
                width: 7; height: parent.height
                source: "images/button1_right.png"
            }
        }

        anchors{bottom: parent.bottom; bottomMargin: 240; horizontalCenter: parent.horizontalCenter}

        Text{
            text:"给我们提意见"
            font{pointSize: 23}
            anchors.centerIn: parent
            color: "#535353"
        }

        MouseArea{
            id: feedback_area
            anchors.fill: parent

            onClicked: {
                pageStack.push(Qt.resolvedUrl("FeedbackPage.qml"));
            }
        }


        states: [
             State {
                 name: 'pressed'; when: feedback_area.pressed
                 PropertyChanges { target: rect_cover; focus: true; opacity: 0.5}
             }
         ]

        Rectangle{
            id: rect_cover
            anchors.fill: parent
            radius: 10
            color: "black"
            opacity: 0
        }
    }

    onLoaded:{
        console.debug("about loaded finish");
        about_page.finish();
    }
}
