import QtQuick 1.0
import com.nokia.meego 1.0
import "Const.js" as Const
import "Database.js" as DBUtil

CustomPage {
    id: loginout_page

//    tools:BackToolBar{}

    property string username

    onLoaded: {
        console.debug("login out page load finish");
        getAccount();
    }

    onOpenPage: {
        pageStack.replace(Qt.resolvedUrl("AccountPage.qml"));
    }

    TopSettingBack{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "网易通行证"

        BackButton{
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}
        }
    }

    Rectangle{
        id: body
        width: parent.width; height: parent.height - top_bar
        anchors{left: parent.left; top: top_bar.bottom}
        color: Const.Color.background

        Rectangle{
            id: user
            width: parent.width - 30; height: 160
            border{color: Const.Color.itemBorder; width: 1}
            anchors{horizontalCenter: parent.horizontalCenter; top: parent.top; topMargin: 20}
            radius: 10

            Image{
                width: 114; height: 114
                anchors{left: parent.left; leftMargin: 15; top: parent.top; topMargin: 10}
                source: "images/Icon.png"
            }

            Text{
                    id: username
                    color: Const.Color.listTitle
                    font{pointSize: 16}
                    text: loginout_page.username
                    width: parent.width - 30; height: 50
                    horizontalAlignment: Text.AlignRight
                    verticalAlignment: Text.AlignVCenter

                    anchors{horizontalCenter: parent.horizontalCenter; top: parent.top}
                }


                Item{
                width: parent.width - 30; height: 80
                anchors{top: username.bottom; right: parent.right; rightMargin: 15}
                Rectangle{
                    width: parent.width / 3; height: parent.height / 2
                    color: Const.Color.rectTrans
        Row{
            anchors.fill: parent
            Image{
                id: left_img
                width: 7; height: parent.height
                source: "images/button1_left.png"
            }

            Image {
                id: middle_img
                width: parent.width - left_img.width - right_img.width; height: parent.height
                source: "images/button1_mid.png"

            }
            Image{
                id: right_img
                width: 7; height: parent.height
                source: "images/button1_right.png"
            }
        }

                    anchors{right: parent.right; verticalCenter: parent.verticalCenter}

                    Text{
                        text:"注销"
                        font{pointSize: 20}
                        anchors.centerIn: parent
                        color: "#535353"
                    }

                    PressArea{
                        anchors.fill: parent
                        pressRadius: 10

                        onClicked: {
                            console.debug("login out");
                            DBUtil.removeAccount(loginout_page.username);
                            loginout_page.jumpPage();
                        }
                    }
                }
                }


                Text{
                    width: parent.width - 30; height: 40
                    anchors{horizontalCenter: parent.horizontalCenter; bottom: user.bottom}
                    color: Const.Color.listWord
                    font{pointSize: 16}
                    text: "登录后就可以发表，回复跟帖了"

                    horizontalAlignment: Text.AlignLeft
                    verticalAlignment: Text.AlignVCenter
                }
        }

    }

    function getAccount(){
        var account = DBUtil.getAccount();
        loginout_page.username = account.username;
        loginout_page.finish();
    }
}
