import QtQuick 1.0
import com.nokia.meego 1.0
import "Const.js" as Const
import "Common.js" as Common
import "Database.js" as DBUtil

CustomPage {
    id: account_page

//    tools: BackToolBar{}

    onLoaded: {
        console.debug("account load finish");
        account_page.finish();
    }

    onOpenPage: {
        pageStack.replace(Qt.resolvedUrl("AccountLoginOutPage.qml"));
    }

    TopSettingBack{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "登录网易通行证"

        BackButton{
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}
        }
    }

    Rectangle{
        width: parent.width; height: parent.height - top_bar.height
        color: Const.Color.background
        anchors{left: parent.left; top: top_bar.bottom}


        Item{
            id: email_item
            anchors{horizontalCenter: parent.horizontalCenter; top: parent.top}
            width: parent.width - 30; height: 100

            TextField{
                id: email
                placeholderText: "请输入通行证账号"
                anchors{verticalCenter: parent.verticalCenter}
                width: parent.width; height: 60
                Text{
                    id: left_text
                    anchors{left: parent.left; leftMargin: 10; verticalCenter: parent.verticalCenter}
                    width: 90; height: 50
                    text: "账号:"
                    color: "black"
                    font{pointSize: 18}

                    horizontalAlignment: Text.AlignLeft
                    verticalAlignment: Text.AlignVCenter


                }
                platformStyle: TextFieldStyle{paddingLeft: left_text.width + 10}
            }
        }
        Item{
            id: pwd_item
            anchors{horizontalCenter: parent.horizontalCenter; top: email_item.bottom}
            width: parent.width - 30; height: 100
            TextField{
                id: pwd
                placeholderText: "请输入通行证密码"
                anchors{verticalCenter: parent.verticalCenter}
                echoMode: TextInput.Password
                width: parent.width; height: 60
                Text{
                    id: pwd_text
                    anchors{left: parent.left; leftMargin: 10; verticalCenter: parent.verticalCenter}
                    width: 90; height: 50
                    text: "密码:"
                    color: "black"
                    font{pointSize: 18}


                    horizontalAlignment: Text.AlignLeft
                    verticalAlignment: Text.AlignVCenter


                }
                platformStyle: TextFieldStyle{paddingLeft: pwd_text.width + 10}
            }
        }

        Item{
            id: vote_btn
            width: parent.width - 30; height: 80
            anchors{horizontalCenter: parent.horizontalCenter; top: pwd_item.bottom}

            Rectangle{
                    color: Const.Color.rectTrans
        Row{
            anchors.fill: parent
            Image{
                id: left_img
                width: 7; height: parent.height
                source: "images/button1_left.png"
            }

            Image {
                id: middle_img
                width: parent.width - left_img.width - right_img.width; height: parent.height
                source: "images/button1_mid.png"

            }
            Image{
                id: right_img
                width: 7; height: parent.height
                source: "images/button1_right.png"
            }
        }
                    width: parent.width * 3 / 4; height: parent.height - 30
                    anchors{horizontalCenter: parent.horizontalCenter; verticalCenter: parent.verticalCenter}

                    Text{
                        anchors.fill: parent
                        color: Const.Color.article
                        font{pointSize: 20}
                        text: "登录"
                        anchors.centerIn: parent

                        horizontalAlignment: Text.AlignHCenter
                        verticalAlignment: Text.AlignVCenter
                    }

                    PressArea{
                        anchors.fill: parent
                        pressRadius: 10
                        onClicked: {
                            console.debug("vote btn on");
                            submit();
                        }
                    }
                }
            }

    }

    function submit(){
        if(pwd.text === ""){
            account_page.showInfo("请填写通行证密码");
            return;
        }
        if(email.text === ""){
            account_page.showInfo("请填写通行证账号");
            return;
        }
        var params = "username="+email.text+"&password="+pwd.text;
        console.debug(params);
        account_page.begin();
        var doc = new XMLHttpRequest();
        doc.onreadystatechange = function() {
            if ((doc.readyState === 4) && (doc.status === 200)) {
                account_page.connectioned();
                console.debug(doc.responseText);

                if(doc.responseText.indexOf("正在登录") > 0){
                    console.debug();
                    account_page.connect(doc.responseText.indexOf("正在登录"));
                    account_page.showInfo("登录成功");
                    account_page.finish();
                    DBUtil.addAccount(email.text,pwd.text,email.text);
                    account_page.jumpPage();
//                    Common.getStringByUrl("GET", "http://comment.api.163.com/api/json/user/load/"+email.text, accountCallback);
                }else if(doc.responseText.indexOf("您的密码不正确") > 0){
                    account_page.showInfo("对不起，您的密码不正确");
                    account_page.finish();
                }else{
                    account_page.showInfo("登录失败");
                    account_page.finish();
                }

            }
        }
        doc.open("POST", "http://reg.163.com/logins.jsp", true);
        doc.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        doc.send(params);
    }

    function accountCallback(responseText){
        account_page.connectioned();
        var obj = JSON.parse(responseText);
        if(obj.code === "1"){
            var account = obj["userinfo"];
            var nickname = account.nickname;
            account_page.showInfo("登录成功");
            account_page.finish();
            DBUtil.addAccount(email.text,pwd.text,email.text);
            account_page.jumpPage();
        }else{
            account_page.showInfo(obj.errMsg);
            account_page.finish();
        }
    }

}
