import QtQuick 1.0
import "Const.js" as Const

Item {
    id: root

    property alias name: item_text.text
    signal clicked

    Row{
        anchors.fill: parent
        Image{
            id: left_img
            width: 14; height: 55
            source: "images/comment1_left.png"
        }

        Image {
            id: middle_img
            width: parent.width - left_img.width - right_img.width; height: 55
            fillMode: Image.TileHorizontally
            source: "images/comment1_mid.png"

        }
        Image{
            id: right_img
            width: 14; height: 55
            source: "images/comment1_right.png"
        }
    }

    Text {
        id: item_text
        font{pointSize: Const.FontSize.menuSize}
        anchors.centerIn: parent
        color: "white"
    }

    MouseArea
    {
        anchors.fill: parent
        onClicked: root.clicked()
    }
}
