import QtQuick 1.0
import "Const.js" as Const

Rectangle {
    id: container

    width: 480; height: 100

    property alias replyCount: reply_count.text
    property alias replyContent: content_text.text
    property string docId: ""
    property string replyBoard
    property string type: Const.Comment.Today

    gradient: Gradient {
        GradientStop { position: 0.0; color: "#EAEAEB" }
        GradientStop { position: 0.1; color: "#EDEDEE" }
        GradientStop { position: 1; color: "#EDEDEE" }
    }

    border{color: "#DDDDDD"; width: 1}
    Row{
        anchors.fill: parent
        spacing: 15
        Item{
            width: 1; height: container.height
        }

        Rectangle{
            width: 85; height: container.height
            color: Const.Color.rectTrans
            Rectangle{
                id: reply_rect
                width: 85; height: 45
                anchors.centerIn: parent
                color: "#CAC0AE"
                radius: 8
                clip: true
                Rectangle{
                    anchors.fill: parent
                    gradient: Gradient {
                        GradientStop { position: 0.0; color: "#E9E2D3" }
                        GradientStop { position: 1; color: "#CEC0A7" }
                    }
                    border{width: 2; color: "#EDEDEE"}
                    radius: 8
                    Text{
                        id: reply_count
                        anchors.centerIn: parent
                        font{pointSize: Const.FontSize.commentSize}
                        color: "#866C3B"

                    }
                }
            }
        }

        Text{
            id: content_text
            color: "black"
            font{pointSize: Const.FontSize.menuSize}
            wrapMode: Text.Wrap
            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
            width: 319; height: container.height

        }
        Rectangle{
            width: 50; height: container.height
            color: Const.Color.rectTrans
            Image{
                anchors.centerIn: parent
                source: "images/cell_right_arraw.png"
            }
        }
    }

    PressArea{
        id: itemMouseArea
        anchors.fill: parent

        onClicked: {
            mainPage.pageStack.push(Qt.resolvedUrl("CommentPage.qml"),{docId: container.docId, replyBoard: container.replyBoard, title: container.replyContent, commentType: ""});
        }
    }

}
