import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const
import "Common.js" as Common
import "Component"
import "RunMemory.js" as MemoryUtil

Page {
    id: comment_main
    orientationLock: PageOrientation.LockPortrait

    property int pageIndex: 0
    property int pageSize: 10

    property bool btn_enabled: true

    property string currentTid: Const.Comment.Ties
    onStatusChanged: {
//        if(PageStatus.Active === comment_main.status){
//            // relashed page
//            if(MemoryUtil.reflashable === true && MemoryUtil.reflashPage === "comments"){
//                changeMenu(menu_view.currentIndex ,comment_main.currentTid);
//            }
//            MemoryUtil.reflashPage = "";
//            MemoryUtil.reflashable = false;
//        }
    }
    TopBackGround{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "跟帖"

        onClicked: {
            console.log("go to top");
            news_list.positionViewAtBeginning();
        }

        ReloadButton{
            id: reload_rect
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}

            onClicked: {
                changeMenu(menu_view.currentIndex ,comment_main.currentTid);
            }
        }

        Rectangle{
            id: setting_rect
            width: parent.height; height: parent.height
            color: Const.Color.rectTrans
            anchors{right: parent.right; top: parent.top}

            Item{
                id: setting_btn
                width: 55; height: 55
                anchors.centerIn: parent
                Image{
                    source: "images/setting.png"
                    anchors.fill: parent
                }
            }
            MouseArea{
                anchors.fill: parent

                onClicked: {
                    mainPage.pageStack.push(Qt.resolvedUrl("InfoMainPage.qml"),{reflashPage: "comments"});
                }
            }
        }

    }

    Rectangle{
        id: menu_bar
        width: parent.width; height: 70
        anchors{top: top_bar.bottom; left: parent.left}
        gradient: Gradient {
            GradientStop { position: 0.0; color: Const.Color.itemTop }
            GradientStop { position: 1; color: Const.Color.itemBottom }
        }
        border{color: Const.Color.itemBorder; width: 1}
        z: 10
        ListView{
            id: menu_view
            model: menu_model
            delegate: menu_delegate

            anchors.centerIn: parent
            width: parent.width * 3 / 4; height: 48

            orientation: ListView.Horizontal
            interactive: false
        }

    }

    ListModel{
        id: menu_model
        ListElement{name:"精彩跟帖";aid: "ties"}
        ListElement{name:"今日排行";aid: "today"}
        ListElement{name:"本周排行";aid: "week"}
    }

    Component{
        id: menu_delegate
        Rectangle{
            width: 120; height: 48
            color: Const.Color.rectTrans
            MenuButton{
                anchors.fill: parent
                itemText: name
                visible: index === menu_view.currentIndex
            }
            Rectangle{
                anchors.fill: parent
                visible: index !== menu_view.currentIndex
                color: Const.Color.rectTrans
                Text{
                    color: "#898C8D"
                    text: name
                    font{pointSize: Const.FontSize.menuSize; bold: true}
                    anchors.centerIn: parent
                }
            }
            MouseArea{
                anchors.fill: parent
                onClicked: {
                    changeMenu(index, aid);
                }
            }
        }
    }

    Rectangle{
        id: common_content
        anchors{top: menu_bar.bottom; left: parent.left}
        width: parent.width; height: parent.height - top_bar.height - menu_bar.height
        color: Const.Color.background

        ReloadBackground{
            id: reload_back
            anchors.fill: parent
            visible: false
        }

        ListView{
            id: news_list
            anchors.fill: parent

            model: listModel
            delegate: listDelegate


        }


        ScrollDecorator{
            flickableItem: news_list
            platformStyle: ScrollDecoratorStyle{inverted: false}
        }
    }

    ListModel{
        id: listModel
    }

    Component{
        id: listDelegate

        Rectangle{
            id: content_rect
            width: comment_main.width; height: comment_reply.height + comment_desc.height

            color: Const.Color.rectTrans
            anchors{leftMargin: 12; rightMargin: 12}

            CommentContentBack{
                id: comment_reply
                width: parent.width - 30
                itemText: content

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.top: parent.top
                anchors.topMargin: 10

            }

            Rectangle{
                id: comment_desc
                width: parent.width - 30; height: 60
                color: Const.Color.rectTrans
                anchors{left: parent.left; top: comment_reply.bottom; bottomMargin: 10}

                Column{
                    anchors.fill: parent
                    Text{
                        id: common_ancher
                        width: comment_desc.width; height: 25
                        color: "#0F719A"
                        font{pointSize: 16}
                        text: anchor

                        horizontalAlignment: Text.AlignRight
                        verticalAlignment: Text.AlignVCenter
                    }

                    Text{
                        id: common_article
                        width: comment_desc.width; height: 25
                        color: "#4C4C4C"
                        font{pointSize: 16}
                        text: article

                        horizontalAlignment: Text.AlignRight
                        verticalAlignment: Text.AlignVCenter

                        elide: Text.ElideRight
                    }
                }

            }

            PressArea{
                id: itemMouseArea
                anchors.fill: parent

                onClicked: {
                    console.log("just to comment content");
                    mainPage.pageStack.push(Qt.resolvedUrl("CommentPage.qml"), {docId: docid, replyBoard: replyboard, title: common_article.text, currentP: p})
                }
            }

       }
    }

    Component{
        id: commentDelegate
        Rectangle{
            id: content_rect
            width: 480;height: 100

            color: Const.Color.rectTrans
            anchors.margins: 15
            CommentListDelegate{
                replyContent: content
                replyCount: count
                docId: docid
                type: comment_main.currentTid
                replyBoard: replyboard

                anchors.fill: parent
            }
        }
    }


    Component{
        id: list_footer
        Item{
            width: comment_main.width; height: 80
            Rectangle{
                width: parent.width * 3 / 4; height: parent.height - 20
                anchors.centerIn: parent
                color: Const.Color.rectTrans
        Row{
            anchors.fill: parent
            Image{
                id: left_img
                width: 7; height: parent.height
                source: "images/button1_left.png"
            }

            Image {
                id: middle_img
                width: parent.width - left_img.width - right_img.width; height: parent.height
                source: "images/button1_mid.png"

            }
            Image{
                id: right_img
                width: 7; height: parent.height
                source: "images/button1_right.png"
            }
        }

                Text{
                    color: "#464646"
                    font{pointSize: Const.FontSize.menuSize}
                    width: parent.width - 20; height: parent.height - 10
                    anchors.centerIn: parent

                    horizontalAlignment: Text.AlignHCenter
                    verticalAlignment: Text.AlignVCenter

                    text: "查看下"+comment_main.pageSize+"条"
                }

                PressArea{
                    id: nextPage_btn
                    anchors.fill: parent
                    enabled: comment_main.btn_enabled
                    pressRadius: 10
                    onClicked: {
                        loading.open();
                        comment_main.btn_enabled = false;
                        comment_main.nextPage();
                    }
                }
            }
        }
    }

    BusyLoading{
        id: loading
        anchors.centerIn: parent
    }

    Component.onCompleted: {
        changeMenu(0, Const.Comment.Ties); //初始化页
    }

    function changeMenu(index, tid){
        loading.open();
        reload_back.visible = true;
        menu_view.currentIndex = index;
        comment_main.pageIndex = 0;
        comment_main.currentTid = tid;
        news_list.footer = null;
        console.log("get content by index:"+index);
        news_list.footer = null;
        listModel.clear();
        if(tid === Const.Comment.Ties){
            news_list.delegate = listDelegate;
            getTies();
        }else{
            news_list.delegate = commentDelegate;
            getRanks(tid);
        }
    }

    function getTies(){
        Common.getStringByUrl("GET", "http://c.3g.163.com/nokia/nc/comment/ties/"+comment_main.pageIndex+"-"+comment_main.pageSize+".html", tiesCallback);
    }

    function tiesCallback(responseText){
        var obj = JSON.parse(responseText);
//        listModel.append(obj.default-topicset);
        var comments = obj.ties;
        for(var i in comments){
            var c = comments[i];
            listModel.append({
                                 "docid": c.docid,
                                 "anchor": c.author,
                                 "article": c.title,
                                 "content": c.tie,
                                 "count": 0,
                                 "replyboard": c.replyBoard,
                                 "p": c.floor

                             });
        }
        news_list.footer = list_footer;
        comment_main.pageIndex += comment_main.pageSize;
        reload_back.visible = false;
        comment_main.btn_enabled = true;
        loading.close();
    }

    function getRanks(tid){
        Common.getStringByUrl("GET","http://c.3g.163.com/nokia/nc/comment/rank/"+tid+".html",rankCallback);
    }

    function rankCallback(responseText){
        var obj = JSON.parse(responseText);
        for(var k in obj){
            var rank = obj[k];
            for(var i in rank){
                var r = rank[i];
                listModel.append({
                                     "docid": r.postid,
                                     "content": r.title,
                                     "count": r.replyCount,
                                     "replyboard": r.replyBoard
                                 });
            }
        }
        reload_back.visible = false;
        loading.close();
    }

    function nextPage(){
        loading.open();
        Common.getStringByUrl("GET", "http://c.3g.163.com/nokia/nc/comment/ties/"+comment_main.pageIndex+"-"+comment_main.pageSize+".html", tiesCallback);
    }
}
