import QtQuick 1.0
import "Common.js" as Common
import "Const.js" as Const


Rectangle{
    id: root

    property int upNum: 0
    property string postId
    property string boardId

    signal replyed
    signal uped

    gradient: Gradient {
        GradientStop { position: 0.0; color: "#444444" }
        GradientStop { position: 0.5; color: "#444444" }
        GradientStop { position: 1; color: "#242424" }
    }

    height: 60; width: 222
    visible: false
    radius: 10
    border{color: "black"; width: 2}
    z: 40

    Item{
        id: item_up
        anchors{left: parent.left; verticalCenter: parent.verticalCenter}
        height: 60; width: 120


        Text{
            id: up_text
            color: "#FFFFFF"
            font.pixelSize: 22
            text: "顶[0]"
            anchors.fill: parent
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }

        PressArea{
            anchors.fill: parent
            onClicked: {
                console.debug("up floor");
                upComment();
                close();
                root.uped();
            }
        }

    }

    Rectangle{
        id: line_1
        anchors{left: item_up.right; verticalCenter: parent.verticalCenter}
        color: "#E5E5E5"
        width: 1; height: parent.height - 2
    }

    Rectangle{
        id: line_2
        color: "#2A2A2A"
        anchors{left: line_1.right; verticalCenter: parent.verticalCenter}
        width: 1; height: parent.height - 2
    }

    Item{
        id: item_reply

        anchors{left: line_2.right; verticalCenter: parent.verticalCenter}
        width: 100; height: 60


        Text{
            id: reply_text
            color: "#FFFFFF"
            font.pixelSize: 22
            anchors.fill: parent
            text: "回复"
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
        }

        PressArea{
            anchors.fill: parent
            onClicked: {
                console.debug("reply floors");
                close();
                root.replyed();
            }
        }
    }

    function upComment(){//
        console.debug("up url:http://comment.news.163.com/reply/upvote/"+root.boardId+"/"+root.postId)
        var doc = new XMLHttpRequest();
        doc.onreadystatechange = function() {
                    console.debug("up state:"+doc.readyState);
                    if ((doc.readyState == 4) && (doc.status == 200)) {
                        console.debug("up back");

                    }
                }
        doc.open("POST", "http://comment.news.163.com/reply/upvote/"+root.boardId+"/"+root.postId, true);
        doc.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        doc.send();
    }

    function open(y, boardid, postid, v){
        root.boardId = boardid;
        root.postId = postid;
        root.upNum = v;
        root.y = y;
        up_text.text = "顶["+root.upNum+"]";
        reply_text.text = "回复";
        root.visible = true;

    }

    function close(){
        root.visible = false;
    }
}

