import QtQuick 1.0
import "Const.js" as Const
import "Common.js" as Common

Item {
    id: root

    signal clicked

    property string author
    property string number
    property string comment
    property bool showLine: false
    property int isHide: 0

    height: root.isHide === 1 ? hide_rect.height : comment_item.height
    Rectangle{
        color: "#A1A1A1"
        height: 1; width: parent.width
        visible: root.showLine
        anchors{horizontalCenter: parent.horizontalCenter; top: parent.top}
    }

    Item {
        id: hide_rect

        height: 50; width: parent.width
        visible: root.isHide === 1
        anchors{left: parent.left; top: parent.top}
        Text{
            id: hide_text
            color: Const.Color.author
            width: parent.width - 36; height: parent.height - 10
            anchors.centerIn: parent
            font{pointSize: 18}

            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter

            text: "隐藏楼层"

            elide: Text.ElideRight
        }

        PressArea{
            anchors.fill: parent
            enabled: root.isHide === 1
            onClicked: {
                console.debug("show hide");
                root.clicked();
            }
        }
    }

    Item{
        id: comment_item
        width: parent.width; height: author_text.height + comment_text.height + 25
        visible: root.isHide === 0
        anchors{left: parent.left; top: parent.top}
        Text{
            id: author_text
            color: Const.Color.author
            width: parent.width - 36; height: 30
            anchors{left: parent.left; leftMargin: 3; top: parent.top}
            font{pointSize: 14}
            text: root.author

            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter

            elide: Text.ElideRight
        }

        Text{
            id: number_text
            color: "#393939"
            font{pointSize: 14}
            anchors{right: parent.right; rightMargin: 3; top: parent.top}
            width: 30; height: 30
            text: root.number

            horizontalAlignment: Text.AlignRight
            verticalAlignment: Text.AlignVCenter
        }

        Text{
            id: comment_text
            font{pointSize: 17; wordSpacing: 2}
            wrapMode: Text.Wrap
            width: parent.width - 36
            anchors{horizontalCenter: parent.horizontalCenter; bottom: parent.bottom; bottomMargin: 15}

            text: root.comment
            textFormat: Text.RichText
            color: "black"
        }

    }

}
