import QtQuick 1.0

Rectangle{
    id: show_btn
    color: "#2F2F2F"
    height: 60; width: root.hasHide ? item_up.width + item_reply.width + item_showfull.width + 2 : item_up.width + item_reply.width + 1
    anchors.horizontalCenter: parent.horizontalCenter
    visible: false
    radius: 10
    border{color: "#828282"; width: 1}
    z: 40

    property type name: value
    Text{
        id: item_up
        color: "white"
        font{pointSize: 16; bold: true}
        anchors{left: parent.left; verticalCenter: parent.verticalCenter}
        height: 60; width: 120
        text: "顶["+root.upNum+"]"

        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter

        PressArea{
            anchors.fill: parent

            onClicked: {
                console.debug("up floor");
                show_btn.visible = false;
            }
        }
    }
    Rectangle{
        id: line_1
        anchors{left: item_up.right; verticalCenter: parent.verticalCenter}
        color: "#E5E5E5"
        width: 1; height: parent.height
    }
    Text{
        id: item_reply
        color: "white"
        font{pointSize: 16; bold: true}
        anchors{left: line_1.right; verticalCenter: parent.verticalCenter}
        width: 60; height: 60
        text: "回复"

        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter

        PressArea{
            anchors.fill: parent

            onClicked: {
                console.debug("reply floors");
                show_btn.visible = false;

            }
        }
    }
    Rectangle{
        id: line_2
        color: "#E5E5E5"
        visible: root.hasHide
        anchors{left: item_reply.right; verticalCenter: parent.verticalCenter}
        width: 1; height: parent.height
    }
    Text{
        id: item_showfull
        color: "white"
        font{pointSize: 16; bold: true}
        width: 120; height: 60
        text: "显示全部"
        anchors{left: line_2.right; verticalCenter: parent.verticalCenter}
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        visible: root.hasHide

        PressArea{
            anchors.fill: parent

            onClicked: {
                console.debug("creat full floors");
                createFullComment();
                show_btn.visible = false;
            }
        }

    }
}
