import QtQuick 1.0
import "../Const.js" as Const

Rectangle {
    id: menuButton
    width: 100
    height: 48
    property alias itemText: item_text.text
    property bool textBold: true

    color: Const.Color.rectTrans
    signal clicked

    Row{
        anchors.fill: parent
        Image{
            id: left_img
            width: 10; height: 48
            source: "../images/navbar_selected_background_left.png"
        }

        Image {
            id: middle_img
            width: parent.width - left_img.width - right_img.width; height: 48
            source: "../images/navbar_selected_background.png"

        }
        Image{
            id: right_img
            width: 10; height: 48
            source: "../images/navbar_selected_background_right.png"
        }
    }

    Text {
        id: item_text
        font{pointSize: Const.FontSize.menuSize; bold: menuButton.textBold}
        anchors.centerIn: parent
        color: "white"
    }

    MouseArea
    {
        anchors.fill: parent
        onClicked: menuButton.clicked()
    }
}
