import QtQuick 1.0
import "../Const.js" as Const
import "../Common.js" as Common
import "../Component"
import "../RunMemory.js" as MemoryUtil

Item {
    id: root

    property int total: 1
    property int current: 0
    property alias color: pro_rect.color

    property bool isCounted: false

    Rectangle{
        id: pro_rect
        width: (parent.width - 50) * root.current / root.total; height: 15
        anchors{verticalCenter: parent.verticalCenter; left: parent.left}

    }

    Text{
        id: progress_text
        color: "#929292"
        anchors{left: pro_rect.right; verticalCenter: parent.verticalCenter; leftMargin: 10}
        font{pointSize: 14}

    }


    function count(total, current, isLast){
        console.debug("count progress:"+total+"; "+current+"; "+isLast);
        if(root.isCounted){
            return;
        }

        if(!isLast){

            var p = Common.countProgress(total, current);
            console.debug("progress:"+p+"; now:"+MemoryUtil.getNowProgress());
            MemoryUtil.addProgress(parseInt(p));
            progress_text.text = p + "%";
        }else{
            progress_text.text = (100 - MemoryUtil.getNowProgress()) + "%";

        }
        root.isCounted = true;
    }

}
