import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const

Page {
    id: root

    orientationLock:PageOrientation.LockPortrait;

    signal loaded

    signal openPage

    Rectangle{
        id: background
        gradient: Gradient {
            GradientStop { position: 0.0; color: Const.Color.backgroundTop }
            GradientStop { position: 1; color: Const.Color.backgroundBottom }
        }
        anchors.fill: parent
    }

    InfoShow{
        id: infoShow
        anchors{bottom: parent.bottom; bottomMargin: 70}
    }

    Timer {
         id: loadwait
          interval: 100
          running: false
          repeat: false
          onTriggered: {
              begin();
              root.loaded();
          }
   }

    Timer {
         id: timerWait
          interval: 100
          running: false
          repeat: false
          onTriggered: {
              root.openPage();
          }
   }

    Timer {
         id: connectOuttime
          interval: 30000
          running: false
          repeat: false
          onTriggered: {
              loading.close();
              infoShow.open("网络超时，页面打开失败");
          }
   }

    BusyLoading{
        id: loading
        anchors.centerIn: parent
    }

   Component.onCompleted: {
       loading.open();
       loadwait.running = true;
   }

   function showInfo(str){
       finish();
       infoShow.open(str);
   }

   function begin(){
       connectOuttime.running = true;
       loading.open();
   }

   function finish(){
       connectOuttime.running = false;
       loading.close();
   }

   function connectioned(){
       connectOuttime.running = false;
   }

   function connect(){
       connectOuttime.running = true;
   }

   function jumpPage(){
       timerWait.running = true;
   }
}
