var database = openDatabaseSync("NeteaseDBTest", "1.0", "NewsReaderTest", 1000000);

var DB = {
    ReadStatus: "ReadStatus",
    Favorites: "Favorites1",
    Accounts: "Accounts",
    Settings: "Settings",
    Vote: "Vote",
    Columns: "NewsColumns6"
}

var DefaultValue = {
    Pager: "1",
    ArticleSize: "18"
}

/**
 * DoInTrasaction
 * Table constructor :
 *
 */
_doInTransaction(
    function tr(tx){
        console.log("init database............") ;
                var rs = tx.executeSql('CREATE TABLE IF NOT EXISTS '+DB.ReadStatus+'(sequence NUMBER UNIQUE,articleType TEXT, docid TEXT, createTime DATE)');
               _traceResultset(rs) ;
        rs = tx.executeSql('CREATE TABLE IF NOT EXISTS '+DB.Settings+'(sequence NUMBER UNIQUE,articleSize NUMBER,pager NUMBER)');
        _traceResultset(rs) ;
        //create account table
        rs = tx.executeSql('CREATE TABLE IF NOT EXISTS '+DB.Favorites+'(sequence NUMBER UNIQUE,docid TEXT UNIQUE ,title TEXT,img TEXT,favType TEXT, replyBoard TEXT, commentType TEXT, currentP TEXT)');
        _traceResultset(rs) ;
        rs = tx.executeSql('CREATE TABLE IF NOT EXISTS '+DB.Vote+'(sequence NUMBER UNIQUE,voteid TEXT UNIQUE)');
        _traceResultset(rs) ;
        rs = tx.executeSql('CREATE TABLE IF NOT EXISTS '+DB.Columns+'(sequence NUMBER UNIQUE,tid TEXT UNIQUE, name Text, ordernum NUMBER, isChecked NUMBER)');
        _traceResultset(rs) ;
        rs = tx.executeSql('CREATE TABLE IF NOT EXISTS '+DB.Accounts+'(sequence NUMBER UNIQUE,username TEXT UNIQUE, password Text, nickname Text)');
        _traceResultset(rs) ;
//        rs = tx.executeSql('CREATE TABLE IF NOT EXISTS Settings(sequence NUMBER UNIQUE,settingType TEXT)');
//        _traceResultset(rs) ;
        console.log("init finish ... ") ;

    }
) ;


function _getNextSequence(tableName){

    var maxId = 1 ;
    var result = _doInTransaction(
        function tr(tx){
                var rs = tx.executeSql('SELECT sequence FROM ' + tableName + ' order by sequence desc limit 1');
            if(rs.rows.length>0){
                maxId = parseInt(rs.rows.item(0).sequence) + 1 ;
            }
            console.debug("favorite maxid = " + maxId) ;
            _traceResultset(rs) ;
        }
    ) ;
    return maxId ;

}

/********************************************** Accounts **************************/

function isAccountExsit(username){
    var isExist = false;
    _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('SELECT sequence FROM '+DB.Accounts+' WHERE username=?', [username]);
                    _traceResultset(rs) ;
                    for(var i = 0; i < rs.rows.length; i++) {
                        isExist = true;
                    }
        }
    ) ;
    return isExist;
}

function addAccount(username, password, nickname){
    var maxid = _getNextSequence(DB.Accounts) ;
    return _doInTransaction(
        function tr(tx){
                    if(!isAccountExsit(username)){
                        var rs = tx.executeSql('INSERT INTO '+DB.Accounts+' (sequence,username, password, nickname) values (?,?,?,?)', [maxid,username, password,nickname]);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}


function getAccount(){
    var account = new Object();
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+DB.Accounts+' ORDER BY sequence desc');
            for(var i = 0; i < rs.rows.length; i++) {
                 //r += rs.rows.item(i).salutation + ", " + rs.rows.item(i).salutee + "\n"
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.username = rs.rows.item(i).username ;
                _item.password = rs.rows.item(i).password;
                _item.nickname = rs.rows.item(i).nickname;
                account = _item ;
                break;
            }
            _traceResultset(rs) ;

        }
    ) ;
    return account;
}

function removeAccount(username){
        return _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('DELETE FROM '+DB.Accounts+' WHERE username=?', [username]);
             _traceResultset(rs) ;
        }
    ) ;
}

function updateNickname(nickname, username){
    return _doInTransaction(
    function tr(tx){
        var rs = tx.executeSql('UPDATE '+DB.Accounts+' set nickname=? WHERE username=?', [nickname, username]);
         _traceResultset(rs) ;
    }
) ;
}

/********************************************** Columns **************************/

function isColumnsExsit(tid){
    var isExist = false;
    _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('SELECT sequence FROM '+DB.Columns+' WHERE tid=?', [tid]);
                    _traceResultset(rs) ;
                    for(var i = 0; i < rs.rows.length; i++) {
                        isExist = true;
                    }
        }
    ) ;
    return isExist;
}

function addColumns(tid, name){
    return _doInTransaction(
        function tr(tx){
                    if(!isColumnsExsit(tid)){
                        var rs = tx.executeSql('UPDATE '+DB.Columns+' set isChecked=1 where tid=?', [tid]);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}


function insertColumns(tid, name){
    var maxid = _getNextSequence(DB.Columns) ;
    return _doInTransaction(
        function tr(tx){
                    if(!isColumnsExsit(tid)){
                        var rs = tx.executeSql('INSERT INTO '+DB.Columns+' (sequence,tid, name, ordernum, isChecked) values (?,?,?,?,?)', [maxid,tid, name,maxid,0]);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}


function updateColumn(tid, name, isChecked){
    var maxid = _getNextSequence(DB.Columns) ;
    return _doInTransaction(
        function tr(tx){
                    var rs;
                    if(!isColumnsExsit(tid)){
                        rs = tx.executeSql('INSERT INTO '+DB.Columns+' (sequence,tid, name, ordernum, isChecked) values (?,?,?,?,?)', [maxid,tid, name,maxid, isChecked]);
                        _traceResultset(rs) ;
                    }else{
                        rs = tx.executeSql('UPDATE '+DB.Columns+' set isChecked=? where tid=?', [isChecked, tid]);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}

function updateColumns(tid, name, orderNum, isChecked){
    return _doInTransaction(
        function tr(tx){
                    var rs;

                        rs = tx.executeSql('UPDATE '+DB.Columns+' set ordernum=?, isChecked=? where tid=?', [orderNum, isChecked, tid]);
                        _traceResultset(rs) ;

        }

    ) ;
}

function getNonColumns(){
    var favorites = new Array();
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+DB.Columns+' where isChecked=0 ORDER BY ordernum asc');
            for(var i = 0; i < rs.rows.length; i++) {
                 //r += rs.rows.item(i).salutation + ", " + rs.rows.item(i).salutee + "\n"
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.tid = rs.rows.item(i).tid ;
                _item.tname = rs.rows.item(i).name;
                _item.order = rs.rows.item(i).ordernum;
                _item.isChecked = rs.rows.item(i).isChecked;
                favorites[i] = _item ;
            }
            _traceResultset(rs) ;

        }
    ) ;
    return favorites ;
}

function getAllColumns(){
    var favorites = new Array();
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+DB.Columns+' ORDER BY ordernum asc');
            for(var i = 0; i < rs.rows.length; i++) {
                 //r += rs.rows.item(i).salutation + ", " + rs.rows.item(i).salutee + "\n"
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.tid = rs.rows.item(i).tid ;
                _item.tname = rs.rows.item(i).name;
                _item.order = rs.rows.item(i).ordernum;
                _item.isChecked = rs.rows.item(i).isChecked;
                favorites[i] = _item ;
            }
            _traceResultset(rs) ;

        }
    ) ;

    return favorites ;
}

function getColumns(){
    var favorites = new Array();
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+DB.Columns+' where isChecked=1 ORDER BY ordernum asc');
            for(var i = 0; i < rs.rows.length; i++) {
                 //r += rs.rows.item(i).salutation + ", " + rs.rows.item(i).salutee + "\n"
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.tid = rs.rows.item(i).tid ;
                _item.tname = rs.rows.item(i).name;
                _item.order = rs.rows.item(i).ordernum;
                _item.isChecked = rs.rows.item(i).isChecked;
                favorites[i] = _item ;
            }
            _traceResultset(rs) ;

        }
    ) ;

    return favorites ;
}

function removeColumn(tid){
        return _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('UPDATE '+DB.Columns+' isChecked=0 WHERE tid=?', [tid]);
             _traceResultset(rs) ;
        }
    ) ;
}

/********************************************** read status **************************/

function _getReadStatusNextMaxId(){

    var maxId = 1 ;
    var result = _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('SELECT sequence FROM '+DB.ReadStatus+' order by sequence desc limit 1');
            if(rs.rows.length>0){
                maxId = parseInt(rs.rows.item(0).sequence) + 1 ;
            }
            console.debug("ReadStatusNextMaxId = " + maxId) ;
            _traceResultset(rs) ;
        }
    ) ;
    return maxId ;

}

/**
  * add read status
  * article type : 'Article', 'Topic'
  * docid: article doc id
  *
  */
function addReadStatus(articleType , docid){
    var maxid = _getReadStatusNextMaxId() ;
    return _doInTransaction(
        function tr(tx){
            if(!isReadStatusExists(articleType, docid)){
                var rs = tx.executeSql('INSERT INTO '+DB.ReadStatus+'(sequence,articleType,docid,createTime) values (?,?,?,?)', [maxid,articleType,docid,new Date()]);
                _traceResultset(rs) ;
                console.debug(" Add read status for "+docid+" type:"+articleType);
            }
        }

    ) ;
}

/**
  * check the article has read
  */
function isReadStatusExists(articleType , docid){
    var isExist = false;
    _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('SELECT sequence FROM '+DB.ReadStatus+' WHERE articleType=? AND docid=?', [articleType,docid]);
                    _traceResultset(rs) ;
                    for(var i = 0; i < rs.rows.length; i++) {
                        console.debug("article :"+ docid + " has readed. type:"+articleType);
                        isExist = true;
                    }
        }
    ) ;
        return isExist;
}

/**
  * Clear the old read status
  *
  */
function removeReadStatus(){
    var lineS = new Date().getTime - (30 * 24 * 3600);
    var removeLine = new Date(lineS);
        return _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('DELETE FROM '+ DB.ReadStatus +' WHERE createTime<?', [removeLine]);
                    console.debug("clear read status : tx=" + tx + "params :" + removeLine) ;
                    _traceResultset(rs) ;
        }
    ) ;
}

/**
  * Get the read status by type
  *
  */
function getReadStatusByType(articleType){
    var readStatus = new Array();
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+ DB.ReadStatus +' where articleType=? ORDER BY sequence desc', [articleType]);
            for(var i = 0; i < rs.rows.length; i++) {
                 //r += rs.rows.item(i).salutation + ", " + rs.rows.item(i).salutee + "\n"
                console.debug("type:"+rs.rows.item(i).docid);
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.docid = rs.rows.item(i).docid ;
                readStatus[i] = _item ;
            }
            _traceResultset(rs) ;

        }
    ) ;
    return readStatus;
}

/********************************************** Favorite **************************/

function isFavoriteExists(docid, favType){
    var isExist = false;
    _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('SELECT sequence FROM '+DB.Favorites+' WHERE favType=? AND docid=?', [favType,docid]);
                    _traceResultset(rs) ;
                    for(var i = 0; i < rs.rows.length; i++) {
                        console.debug("article :"+ docid + " has readed. type:"+favType);
                        isExist = true;
                    }
        }
    ) ;
    return isExist;
}

function addArticleFavorite(docid ,title){
    var maxid = _getNextSequence(DB.Favorites) ;
    return _doInTransaction(
        function tr(tx){
                    if(!isFavoriteExists(docid,'Article')){
                        var rs = tx.executeSql('INSERT INTO '+DB.Favorites+' (sequence,docid,title,img,favType,replyBoard, commentType, currentP) values (?,?,?,?,?,?,?,?)', [maxid,docid,title,'','Article','','','']);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}

function addPictureFavorite(docid ,title, img){
    var maxid = _getNextSequence(DB.Favorites) ;
    return _doInTransaction(
        function tr(tx){
                    if(!isFavoriteExists(docid,'Pictrue')){
                        var rs = tx.executeSql('INSERT INTO '+DB.Favorites+' (sequence,docid,title,img,favType,replyBoard, commentType, currentP) values (?,?,?,?,?,?,?,?)', [maxid,docid,title,img,'Pictrue','','','']);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}

function addCommentFavorite(docid ,title, replyBoard, commentType, currentP){
    var maxid = _getNextSequence(DB.Favorites) ;
    return _doInTransaction(
        function tr(tx){
                    if(!isFavoriteExists(docid,'Comment')){
                        var rs = tx.executeSql('INSERT INTO '+DB.Favorites+' (sequence,docid,title,img,favType,replyBoard, commentType, currentP) values (?,?,?,?,?,?,?,?)', [maxid,docid,title,'','Comment',replyBoard, commentType, currentP]);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}

function getFavorites(favType){
    var favorites = new Array();
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+DB.Favorites+' where favType=? ORDER BY sequence desc', [favType]);
            for(var i = 0; i < rs.rows.length; i++) {
                 //r += rs.rows.item(i).salutation + ", " + rs.rows.item(i).salutee + "\n"
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.docId = rs.rows.item(i).docid ;
                _item.title = rs.rows.item(i).title ;
                _item.img = rs.rows.item(i).img ;
                _item.favType = rs.rows.item(i).favType ;
                _item.replyBoard = rs.rows.item(i).replyBoard ;
                console.log("item.replyBoard"+_item.replyBoard)
                _item.commentType = rs.rows.item(i).commentType ;
                _item.currentP = rs.rows.item(i).currentP ;
                favorites[i] = _item ;
            }
            _traceResultset(rs) ;

        }
    ) ;

    return favorites ;
}

function removeFavorites(favType){
        return _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('DELETE FROM '+DB.Favorites+' WHERE favType=?', [favType]);
             _traceResultset(rs) ;
        }
    ) ;
}

function removeSingleFavorite(docid, favType){
        return _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('DELETE FROM '+DB.Favorites+' WHERE favType=? And docid=?', [favType, docid]);
             _traceResultset(rs) ;
        }
    ) ;
}

/********************************************** vote **************************/

function isVoted(voteid){
    var isExist = false;
    _doInTransaction(
        function tr(tx){
            var rs = tx.executeSql('SELECT sequence FROM '+DB.Vote+' WHERE voteid=?', [voteid]);
                    _traceResultset(rs) ;
                    for(var i = 0; i < rs.rows.length; i++) {
                        isExist = true;
                    }
        }
    ) ;
    return isExist;
}

function addVote(voteid){
    var maxid = _getNextSequence(DB.Vote) ;
    return _doInTransaction(
        function tr(tx){
                    if(!isVoted(voteid)){
                        var rs = tx.executeSql('INSERT INTO '+DB.Vote+' (sequence,voteid) values (?,?)', [maxid,voteid]);
                        _traceResultset(rs) ;
                    }
        }

    ) ;
}

/********************************************** setting **************************/

function updateArticleSize(articleSize){
    var setting = getSetting();
    if(setting === null){
        var sequence = _getNextSequence(DB.Settings) ;
        return _doInTransaction(
            function tr(tx){
                        var rs = tx.executeSql('INSERT INTO '+DB.Settings+'(sequence,articleSize,pager) values (?,?,?)', [sequence,articleSize, DefaultValue.Pager]);
                    _traceResultset(rs) ;
            }

        ) ;
    }else{

    return _doInTransaction(
        function tr(tx){
                        var rs = tx.executeSql('UPDATE '+DB.Settings+' SET articleSize=? where sequence=?',[articleSize,setting.sequence]);
            _traceResultset(rs) ;

        }
    ) ;
    }
}

function updatePager(pager){
    var setting = getSetting();
    if(setting === null){
        var sequence = _getNextSequence(DB.Settings) ;
        return _doInTransaction(
            function tr(tx){
                        var rs = tx.executeSql('INSERT INTO '+DB.Settings+'(sequence,articleSize,pager) values (?,?,?)', [sequence,DefaultValue.ArticleSize, pager]);
                    _traceResultset(rs) ;
            }

        ) ;
    }else{

    return _doInTransaction(
        function tr(tx){
                        var rs = tx.executeSql('UPDATE '+DB.Settings+' SET pager=? where sequence=?',[pager,setting.sequence]);
            _traceResultset(rs) ;

        }
    ) ;
    }
}

function getSetting(){
    var sysSet = null ;
    _doInTransaction(
        function tr(tx){
                    var rs = tx.executeSql('SELECT * FROM '+DB.Settings);
            console.debug("getSetting execute : tx=" + tx + " | ") ;
            for(var i = 0; i < rs.rows.length; i++) {
                var _item = new Object() ;
                _item.sequence = rs.rows.item(i).sequence ;
                _item.articleSize = rs.rows.item(i).articleSize ;
                _item.pager = rs.rows.item(i).pager ;
                sysSet = _item ;
                console.debug("setting articleSize:"+sysSet.articleSize+";pager:"+sysSet.pager);
                break ;
            }
            _traceResultset(rs) ;

        }
    ) ;

    return sysSet ;
}

/**
  * return : true if success
  */
function _doInTransaction(transactionFunc) {
    try{
        database.transaction(
            function(tx) {
                return transactionFunc(tx) ;
            }
        )
        return true ;
    }catch(e){
        console.log("database error : " + e) ;
        return false ;
    }
}



function _traceResultset(rs){
    var str = "" ;
    if(typeof(rs) == 'undefined' || rs == 'undefined'){
        str = " typeof resultset is undefined!" ;
    }else{
        str = " ResultSet{rows:" + rs.rows.length + "]"

        str += "}" ;
        str += "\r\n" ;
        for(var i = 0; i < rs.rows.length; i++) {
            str += i + "> "
            var item = rs.rows.item(i) ;
            for(var prop in item ){
                str +=  prop + "=" + item[prop] + "|" ;
            }
            str += "\r\n" ;
        }
    }

    console.debug(str) ;
    return str ;
}


/**
  * js显示 confirmDialog
  */
function confirm(text){
    return true ;
}

