import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const
import "Database.js" as DBUtil
import "Common.js" as Common
import "RunMemory.js" as MemoryUtil

CustomPage {
    id: custom_page

//    tools: BackToolBar{}

    property bool listViewMoveable: true
    property bool listViewUpMoveable: false
    property bool listViewDownMoveable: false
    property int moveOffset: 0
    property int currentIndex: 0
    onLoaded: {
        console.debug("custom page finish");
        reload_back.visible = true;
        getNewsTopics();
    }

    property int colNum: 0

    Timer {
         id: move_timer
          interval: 100
          running: false
          repeat: false
          onTriggered: {
              custom_page.listViewMoveable = true;
          }
   }

    Timer {
         id: moveup_timer
          interval: 100
          running: true
          repeat: true
          onTriggered: {
              if(custom_page.listViewUpMoveable){
                  if(listviewcontenty() - 80 > 0){
                      listview.contentY -= 80;
                  }else{
                      if(!listview.atYBeginning){
                          listview.positionViewAtBeginning();
                          custom_page.listViewUpMoveable = false;
                      }
                  }
              }
          }
   }

    Timer {
         id: movedown_timer
          interval: 100
          running: true
          repeat: true
          onTriggered: {
              if(custom_page.listViewDownMoveable){
                  if(listviewcontenty() + 80 < (listview.contentHeight - listview.height)){
                      listview.contentY += 80;
                  }else{
                      if(!listview.atYEnd){
                          listview.positionViewAtEnd();
                          custom_page.listViewDownMoveable = false;
                      }
                  }
              }
          }
   }

    TopSettingBack{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "自定义栏目"

        BackButton{
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}
        }
    }

    Rectangle{
        id: body
        width: parent.width; height: parent.height - top_bar.height
        anchors{left: parent.left; top: top_bar.bottom}
//        color: Const.Color.background
        gradient: Gradient {
            GradientStop { position: 0.0; color: Const.Color.backgroundTop }
            GradientStop { position: 1; color: Const.Color.backgroundBottom }
        }

        ReloadBackground{
            id: reload_back
            anchors.fill: parent
            visible: false
        }

        ListView{
            id: listview
            anchors.fill: parent

            model: listmodel

            delegate:Item{
                id: listItem
                width: body.width; height: isEmpty ? 0 : 80

                Text{
                    width: parent.width - 30; height: parent.height
                    anchors.centerIn: parent

                    horizontalAlignment: Text.AlignLeft
                    verticalAlignment: Text.AlignVCenter

                    font{pointSize: 20}

                    color: Const.Color.listTitle

                    text: tname
                }

                Item{
                    width: parent.width; height: parent.height
                    anchors{right: parent.right; verticalCenter: parent.verticalCenter}


                    MouseArea{
                        id: move_area
                        anchors.fill: parent

                        onPressAndHold: {
                            listview.interactive = false;
                            move_text.text = tname;

                            move_item.y = yInView(isSaved, index, -5) ;
                            custom_page.currentIndex = index;

                            move_item.visible = true;
                        }

                        onReleased: {
                            move_item.visible = false;
                            console.debug("")
                            var i = 1;
                            var moveRect = custom_page.colNum * 80 + 45;
                            console.debug("custom_page.colNum:"+custom_page.colNum);
                            var conY = listviewcontenty();
                            var itemY = move_item.y + 40;
                            console.debug("itemY:"+itemY);
                            console.debug("conY:"+conY);
                            console.debug("(top_bar.height + moveRect - conY):"+(top_bar.height + moveRect - conY));
                            if(itemY < (top_bar.height + moveRect - conY)){
                                var visY = itemY - top_bar.height + conY - 45;
                                console.debug("visY==================>"+visY);
                                if(visY < 0){
                                    i = 1;
                                }else{
                                    i = Math.round(visY / 80) + 1;
                                }
                                console.debug("i:"+i);

                                listmodel.setProperty(custom_page.currentIndex, "isSaved", "导航");
                                if(custom_page.currentIndex < i){
                                    i--;
                                }

                                listmodel.move(custom_page.currentIndex, i, 1);
                                if(i <= 1){
                                    custom_page.moveOffset = listview.contentY;

                                }
                                 console.debug("position changed listview content y:"+listview.contentY);
                                saveColumns();
                            }else{
                                console.debug("current index==========>"+custom_page.currentIndex);
                                if(custom_page.currentIndex < custom_page.colNum + 1){
                                    listmodel.setProperty(custom_page.currentIndex, "isSaved", "更多");

                                }
                                var disY = itemY - top_bar.height + conY;
                                i = Math.round(disY / 80);
                                if(custom_page.currentIndex < i){
                                    i--;
                                }
                                console.debug("i========>"+i);
                                listmodel.move(custom_page.currentIndex, i, 1);
                                saveColumns();
                            }

                            custom_page.listViewUpMoveable = false;
                            custom_page.listViewDownMoveable = false;
                            custom_page.listViewMoveable = false;
                            listview.interactive = true;

                        }


                        onMouseYChanged: {
                            var itemY = yInView(isSaved, index, mouseY);
                            if(custom_page.listViewMoveable && !listview.interactive){
                                custom_page.listViewUpMoveable = false;
                                custom_page.listViewDownMoveable = false;
                                custom_page.listViewMoveable = false;
                                move_item.y = itemY - 40;

                                if(itemY < top_bar.height + 80){
                                    // up
                                    custom_page.listViewUpMoveable = true;

                                }else if(itemY > (listview.height - 80)){
                                    // down
                                    custom_page.listViewDownMoveable = true;
                                }

                                move_timer.running = true;
                            }
                        }

                        onContainsMouseChanged: {
                            console.debug("onContainsMouseChanged:");
                        }

                        onFocusChanged: {
                            console.debug("onFocusChanged:");
                        }

                        onStateChanged: {
                            console.debug("onStateChanged:");
                        }

                        onHoveredChanged: {
                            console.debug("onHoveredChanged:");
                        }
                    }
                }

                Image {
                    id: line
                    source: "images/line.png"
                    width: parent.width
                    anchors{left: parent.left; bottom: parent.bottom}
                }
            }

            section.property: "isSaved"
            section.criteria: ViewSection.FullString
            section.delegate: listSelection

            onFlickStarted: {
                console.debug("list view flick");

            }
        }

        ScrollDecorator{
            flickableItem: listview
            platformStyle: ScrollDecoratorStyle{inverted: false}
        }
    }

    Item{
        id: move_item
        width: body.width; height: 80
        anchors{left: parent.left}
        visible: false
        z: 100

        Text{
            id: move_text
            width: parent.width - 30; height: parent.height
            anchors.centerIn: parent

            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter

            font{pointSize: 20}

            color: "black"

        }
    }

    Component{
        id: listSelection
        Rectangle {
            width: custom_page.width; height: 45
            gradient: Gradient {
                GradientStop { position: 0.0; color: "#C1C1C1" }
                GradientStop { position: 0.1; color: "#C1C1C1" }
                GradientStop { position: 1; color: "#929292" }
            }
            border{color: "#DDDDDD"; width: 1}

            Text {
                id: title
                color: Const.Color.listWord
                font.pointSize: 18
                text: section
                width: parent.width; height: parent.height
                anchors.fill: parent; anchors.leftMargin: 15
                verticalAlignment: Text.AlignVCenter
            }

        }

    }

    ListModel{
        id: listmodel
    }

    function getNewsTopics(){
        console.log("gettopics");
        newsTopicsCallback();
    }

    function newsTopicsCallback(){

        var columns = DBUtil.getAllColumns();
        listmodel.append({
                             "tname": "",
                             "tid": "",
                             "isSaved": "导航",
                             "isEmpty": true
                         });
        for(var k in columns){
            var mm = columns[k];
            var isSaved = "更多";
            if(mm.isChecked === '1'){
                isSaved = "导航";
                custom_page.colNum ++;
            }

            listmodel.append({
                                 "tname": mm.tname,
                                 "tid": mm.tid,
                                 "isSaved": isSaved,
                                 "isEmpty": false
                             });
        }

        listmodel.append({
                             "tname": "",
                             "tid": "",
                             "isSaved": "更多",
                             "isEmpty": true
                         });
        reload_back.visible = false;
        custom_page.finish();

    }

    function saveColumns(){
        custom_page.colNum = 0;
        for(var i=0; i<listmodel.count; i++){
            var item = listmodel.get(i);
            var isChecked = 0;
            if(!item.isEmpty){
                if(item.isSaved === "导航"){
                    custom_page.colNum ++;
                    isChecked = 1;
                }

                DBUtil.updateColumns(item.tid, item.tname, i, isChecked);
                MemoryUtil.columnsChanged = true;
            }
        }
    }

    function yInView(isSaved, index, offset){
        console.debug("INFO listview.contentY:"+listview.contentY);
        if(isSaved === "导航"){
            return top_bar.height + (45 + (index-1) * 80) - listviewcontenty() + offset;
        }else{
            return top_bar.height + (45 * 2 + (index-1) * 80) - listviewcontenty() + offset;
        }
    }

    function listviewcontenty(){
        return listview.contentY - custom_page.moveOffset;
    }
}
