import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const

ToolBarLayout{
    id: container

    signal downloaded
    signal shared
    signal favorited
    signal replyed

    property bool isFavorited: false
    property alias favoriteEnable: favorite_btn.enabled
    property alias downloadEnable: download_btn.enabled


//    ToolIcon{
//        id: back_bt
//        iconId: "toolbar-back"
//        platformStyle: toolBar_style
//        onClicked: {pageStack.pop();}
//    }

    Image {
        id: back
        source: "images/reply_back.png"
        width: parent.width; height: parent.height
        anchors.fill: parent
    }

    Rectangle{
        id: reply_rect
        color: "#E8E8E8"
        radius: 10
        height: parent.height - 15
        border{width: 1; color: "#787878"}
        anchors{left: parent.left; leftMargin: 5; right: download_btn.left; rightMargin: 5; verticalCenter: parent.verticalCenter}

        Image{
            anchors{left:parent.left; leftMargin: 10; verticalCenter: parent.verticalCenter}
            source: "images/toolbar_light_background.png"
        }

        PressArea{
            anchors.fill: parent

            onClicked: {
                reply_rect.visible = false;
                container.replyed();
            }
        }
    }

    ToolButton {
        id: download_btn
        iconSource: "images/toolbar_save.png"
        width: container.width / 6; height: container.height
        anchors.right: favorite_btn.left; anchors.bottom: container.bottom
        platformStyle: toolBar_style
        onClicked: {
            container.downloaded();
        }
    }

//    ToolButton {
//        id: share_btn
//        iconSource: "images/toolbar_rt.png"
//        width: container.width / 6; height: container.height
//        anchors.right: favorite_btn.left; anchors.bottom: container.bottom
//        platformStyle: toolBar_style
//        onClicked: container.shared();
//    }

    ToolButton {
        id: favorite_btn
        iconSource: container.isFavorited ? "images/toolbar_fav.png" : "images/toolbar_fav_empty.png"
        width: container.width / 6; height: container.height
        anchors.right: container.right; anchors.bottom: container.bottom
        platformStyle: toolBar_style
        onClicked: {
            container.favorited();
        }
    }

    ToolButtonStyle{
        id: toolBar_style
        backgroundVisible: false
        pressedBackground: "image://theme/meegotouch-button-navigationbar-button" + __invertedString + "-background-pressed"
    }

    function showImg(){
        reply_rect.visible = true;
    }
}
