import QtQuick 1.0
import "Const.js" as Const

Item {
    id: root

    property alias src: img.source
    property alias title: text.text

    signal clicked

    Image {
        id: line
        source: "images/line.png"
        width: parent.width
        anchors.bottom: parent.bottom
        anchors.left: parent.left
    }

    Item{
        id: content_img
        width: 80; height: parent.height
        anchors{left: parent.left; top: parent.top}
        Image {
            id: img
            anchors.centerIn: parent
        }
    }

    Item{
        id: content_text
        width: parent.width - content_img.width; height: parent.height
        anchors{right: parent.right; top: parent.top}
        Text {
            id: text
            font{pointSize: 19; bold: true}
            color: Const.Color.listTitle
            anchors.fill: parent

            horizontalAlignment: Text.AlignLeft
            verticalAlignment: Text.AlignVCenter
        }
    }

    PressArea{
        anchors.fill: parent
        onClicked: {
            root.clicked();
        }
    }
}
