import QtQuick 1.0
import "RunMemory.js" as MemoryUtil
import com.nokia.meego 1.0

CustomPage{
    id: info_page

    onLoaded: {
        info_page.finish();
    }

    property string reflashPage

    TopBackGround{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: ""

        BackButton{
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}
        }
    }

    Item{
        id: body
        width: parent.width; height: parent.height - top_bar.height
        anchors{left: parent.left; top: top_bar.bottom}

        ListView{
            id: listView
            model: listModel
            delegate: InfoListItem{
                width: body.width; height: 82
                title: name
                src: img

                onClicked: {
                    info_page.clicked(type);
                }
            }
            anchors.fill: parent
        }

        ScrollDecorator{
            flickableItem: listView
            platformStyle: ScrollDecoratorStyle{inverted: false}
        }

    }

    ListModel{

        id: listModel
//        ListElement{name:"刷新";img: "images/info_reflash.png"; type: 1}
        ListElement{name:"自定义栏目";img: "images/info_custom.png"; type: 2}
        ListElement{name:"我的收藏";img: "images/info_fav.png"; type: 3}
        ListElement{name:"设置";img: "images/info_setting.png"; type: 4}
        ListElement{name:"关于";img: "images/info_about.png"; type: 5}
    }

    function clicked(type){
        if(type === 1){// 刷新
//            MemoryUtil.reflashPage = info_page.reflashPage;
//            MemoryUtil.reflashable = true;
//            pageStack.pop();
        }else if(type === 2){
            pageStack.push(Qt.resolvedUrl("EditColumnPage.qml"));
        }else if(type === 3){
            pageStack.push(Qt.resolvedUrl("FavoratePage.qml"));
        }else if(type === 4){
            pageStack.push(Qt.resolvedUrl("SettingMainPage.qml"));
        }else if(type === 5){
            pageStack.push(Qt.resolvedUrl("AboutPage.qml"));
        }
    }
}
