import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.1

Page
{

    id:mainPage
    tools: commonTools
    orientationLock: PageOrientation.LockPortrait

    NewsMainPage{
        id: news_page
    }

    TopicMainPage{
        id: topic_page
    }

    PhotoMainPage{
        id: photo_page
    }

    CommentMainPage{
        id: comment_page
    }

    VoteMainPage{
        id: vote_page
    }

    Component.onCompleted: {
        news_tab.push(news_page);
        topic_tab.push(topic_page);
        photo_tab.push(photo_page);
        comment_tab.push(comment_page);
        vote_tab.push(vote_page);

        theme.inverted = true
    }
    TabGroup {
        id: tabGroup
        currentTab: news_tab

        PageStack {
            id: news_tab

        }
        PageStack {
            id: topic_tab
        }

        PageStack {
            id: photo_tab
        }

        PageStack {
            id: comment_tab
        }

        PageStack {
            id: vote_tab
        }
    }


    ToolBarLayout {
        id: commonTools
        visible: true

        Rectangle{
            anchors.fill: parent
            color: "#3F3F3F"
        }
        MyTab {
            id: btn1
            anchors{right: btn2.left; top: btn5.top}
            width: parent.width / 5; height: parent.height
            tabsource: "images/toolbar/tabbar-news.png"
            selected: tabGroup.currentTab === news_tab
            onClicked: {
                tabGroup.currentTab = news_tab;
            }
        }

        MyTab {
            id: btn2
            anchors{right: btn3.left; top: btn5.top}
            width: parent.width / 5; height: parent.height
            tabsource: "images/toolbar/tabbar-topic.png"
            selected: tabGroup.currentTab === topic_tab
            onClicked: {
                tabGroup.currentTab = topic_tab;
            }

        }
        MyTab {
            id: btn3
            anchors{right: btn4.left; top: btn5.top}
            width: parent.width / 5; height: parent.height
            tabsource: "images/toolbar/tabbar-pictures.png"
            selected: tabGroup.currentTab === photo_tab
            onClicked: {
                tabGroup.currentTab = photo_tab;
            }

        }
        MyTab {
            id: btn4
            anchors{right: btn5.left; top: btn5.top}
            width: parent.width / 5; height: parent.height
            tabsource: "images/toolbar/tabbar-comments.png"
            selected: tabGroup.currentTab === comment_tab
            onClicked: {
                tabGroup.currentTab = comment_tab;
            }

        }
        MyTab {
            id: btn5
            width: parent.width / 5; height: parent.height
            tabsource: "images/toolbar/tabbar-vote.png"
            selected: tabGroup.currentTab === vote_tab
            onClicked: {
                tabGroup.currentTab = vote_tab;
            }

        }
//        Item{
//            anchors.fill:parent


//        ButtonRow {
//            anchors.fill: parent
//            platformStyle: TabButtonStyle {
//                checkedBackground: "image://theme/meegotouch-tab-" + screenOrientation + "-bottom" + __invertedString + "-background" + (position ? "-" + position : "")
////                background: "image://theme/meegotouch-tab-" + screenOrientation + "-bottom" + __invertedString + "-background-selected" + (position ? "-" + position : "")
//            }

//            TabButton {
//                id: btn1
//                text:""
//                width: parent.width / 5; height: parent.height
//                tab: news_tab
//                Image {
//                    anchors{left: parent.left; bottom: parent.bottom}
//                    width: 96; height: 37
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    visible: tabGroup.currentTab === parent.tab
//                    source: "images/toolbar/tab-arrow.png"
////                    source: tabGroup.currentTab === parent.tab ? "images/toolbar/tab-arrow.png" : "images/toolbar/tab-nomal.png"
//                }
//                Image {
//                    id: img_1
//                    anchors.centerIn: parent
//                    smooth: true
//                    width: 96; height: 66
//                    fillMode: Image.PreserveAspectFit
//                    source: "images/toolbar/tabbar-news.png"
//                }

//            }
//            TabButton {
//                id: btn2
//                tab: topic_tab
//                text:""
//                width: parent.width / 5; height: parent.height
//                Image {
//                    anchors{left: parent.left; bottom: parent.bottom}
//                            width: 96; height: 37
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    visible: tabGroup.currentTab === parent.tab
//                    source: "images/toolbar/tab-arrow.png"
////                    source: tabGroup.currentTab === parent.tab ? "images/toolbar/tab-arrow.png" : "images/toolbar/tab-nomal.png"
//                }
//                Image {
//                    id: img_2
//                    anchors.centerIn: parent
//                    width: 96; height: 66
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    source: "images/toolbar/tabbar-topic.png"
//                }

//            }

//            TabButton {
//                id: btn3
//                tab: photo_tab
//                text:""
//                width: parent.width / 5
//                Image {
//                    anchors{left: parent.left; bottom: parent.bottom}
//                            width: 96; height: 37
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    visible: tabGroup.currentTab === parent.tab
//                    source: "images/toolbar/tab-arrow.png"
//                }
//                Image {
//                    id: img_3
//                    anchors.centerIn: parent
//                    width: 96; height: 66
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    source: "images/toolbar/tabbar-pictures.png"
//                }

//            }
//            TabButton {
//                tab: comment_tab
//                text:""
//                width: parent.width / 5
//                Image {
//                    anchors{left: parent.left; bottom: parent.bottom}
//                            width: 96; height: 37
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    visible: tabGroup.currentTab === parent.tab
//                    source: "images/toolbar/tab-arrow.png"
////                    source: tabGroup.currentTab === parent.tab ? "images/toolbar/tab-arrow.png" : "images/toolbar/tab-nomal.png"
//                }
//                Image {
//                    id: img_4
//                    anchors.centerIn: parent
//                    width: 96; height: 66
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    source: "images/toolbar/tabbar-comments.png"
//                }

//            }
//            TabButton {
//                tab: vote_tab
//                text:""
//                width: parent.width / 5
//                Image {
//                    anchors{left: parent.left; bottom: parent.bottom}
//                    width: 96; height: 37
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    visible: tabGroup.currentTab === parent.tab
//                    source: "images/toolbar/tab-arrow.png"
////                    source: tabGroup.currentTab === parent.tab ? "images/toolbar/tab-arrow.png" : "images/toolbar/tab-nomal.png"
//                }
//                Image {
//                    id: img_5
//                    anchors.centerIn: parent
//                    width: 96; height: 66
//                    smooth: true
//                    fillMode: Image.PreserveAspectFit
//                    source: "images/toolbar/tabbar-vote.png"
//                }

//            }
//        }
//        }
        ToolButtonStyle{
            id: toolBar_style
            backgroundVisible: false
            pressedBackground: "image://theme/meegotouch-button-navigationbar-button" + __invertedString + "-background-pressed"
        }

    }



}
