import QtQuick 1.1
import "Const.js" as Const
import "Common.js" as Common

Item {
    id: container

    property string itemTitle
    property string itemContent

    property string itemSource
    property int itemType: 0
    property int replyCount
    property string docid: ""
    property bool isReaded: false

    property bool hasImg: container.itemSource !== ""

    property int contentWord: container.hasImg ? 36 : 50

    signal clicked

    width: 480; height: 125
//    color: Const.Color.rectTrans
//    border{color: "#DDDDDD"; width: 1}

    PressArea{
        id: itemMouseArea
        anchors.fill: parent

        onClicked:{
            content_title.color = Const.Color.listWord;
            container.clicked();
        }
    }
    Item{
        anchors.fill: parent
//        color: Const.Color.rectTrans

        Row{
            anchors.fill: parent
            Item{
                visible: container.hasImg
                width: 5; height: container.height
            }

            Item{
//                color: Const.Color.rectTrans
                width: 120; height: container.height
                visible: container.hasImg
                ImageLoadBackground{
                    anchors.centerIn: parent
                    width: 115; height: 92
                    Image{
                        anchors.fill: parent
                        source: container.itemSource
                    }
                }
            }
            Item{
                width: 5; height: container.height
            }
            Item{
                id: list_content
//                color: Const.Color.rectTrans
                width: container.hasImg ? 348 : 465; height: container.height

                Column{
                    anchors.fill: parent
                    spacing: 4

                    Item{
                        width: list_content.width; height: 8
                    }

                    Item{
                        width: list_content.width; height: 30
//                        color: Const.Color.rectTrans

                        Text{
                            id: content_title
                            font{pointSize: 18; bold: true}
                            color: Const.Color.listTitle
                            anchors.fill: parent
                            text: container.itemTitle

                            horizontalAlignment: Text.AlignLeft
                            verticalAlignment: Text.AlignVCenter

                            elide: Text.ElideRight
                        }
                    }

                    Item{
                        width: list_content.width; height: 50
//                        color: Const.Color.rectTrans

                        Text{
                            id: content_text
                            width: parent.width-5
                            font{pointSize: 16}
                            color: Const.Color.listWord
                            anchors.fill: parent
                            maximumLineCount: 2
                            text: Common.subString(container.itemContent, container.contentWord)
                            horizontalAlignment: Text.AlignLeft
                            verticalAlignment: Text.AlignTop
                            wrapMode: Text.WordWrap
                        }

                    }

                    Item{
                        width: list_content.width; height: 1
                    }
                }
            }


        }

        Image {
            id: line
            source: "images/line.png"
            width: parent.width
            anchors.left: parent.left
            anchors.bottom: parent.bottom
        }
    }



}
