import QtQuick 1.0
import "Const.js" as Const

Rectangle {

    id: container

    color:Const.Color.rectTrans

    property alias enabled: mouse_area.enabled
    property alias pressRadius: rect_cover.radius
    signal clicked
    signal pressAndHolded

    MouseArea{
        id: mouse_area
        anchors.fill: parent


        onClicked: { container.clicked();}

        onPressAndHold: container.pressAndHolded();
    }

    states: [
         State {
             name: 'pressed'; when: mouse_area.pressed
             PropertyChanges { target: rect_cover; focus: true; opacity: 0.5}
         }
     ]

    Rectangle{
        id: rect_cover
        anchors.fill: parent
        color: "black"
        opacity: 0
    }
}
