import QtQuick 1.0
import com.nokia.meego 1.0
import "Const.js" as Const
import "Database.js" as DBUtil
import "RunMemory.js" as MemoryUtil

CustomPage{
    id: setting_main

//    tools: BackToolBar{}

    onLoaded: {
        console.debug("setting page load finish");
        setting_main.finish();
    }

    TopSettingBack{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "设置"

        BackButton{
            width: parent.height; height: parent.height
            anchors{left: parent.left; top: parent.top}
        }
    }

    Rectangle{
        id: body_rect
        width: parent.width; height: parent.height - top_bar.height
        anchors{left: parent.left; top: top_bar.bottom}
        color: Const.Color.background
        Item{
            id: accountRect
            width: parent.width; height: 120
            anchors{left: parent.left; top: parent.top}

            Rectangle{
                width: parent.width - 40; height: parent.height - 40
                anchors.centerIn: parent
                border{color: Const.Color.itemBorder}
                radius: 15
                Text{
                    color: Const.Color.listTitle
                    font{pointSize: 20; bold: true}

                    horizontalAlignment: Text.AlignLeft
                    verticalAlignment: Text.AlignVCenter

                    width: parent.width - 40; height: parent.height
                    anchors.centerIn: parent
                    text: "个人账号"
                }
                Image{
                    anchors{right: parent.right; verticalCenter: parent.verticalCenter}
                    source: "images/cell_right_arraw.png"
                }

                PressArea{
                    anchors.fill: parent
                    onClicked: {
                        if(checkAccount()){
                            pageStack.push(Qt.resolvedUrl("AccountLoginOutPage.qml"));
                        }else{
                            pageStack.push(Qt.resolvedUrl("AccountPage.qml"));
                       }
                    }
                }
            }
        }

        Item{
            id: articleRect
            width: parent.width; height: 200
            anchors{left: parent.left; top: accountRect.bottom}
            Rectangle{
                width: parent.width - 40; height: parent.height - 40
                anchors.centerIn: parent
                border{color: Const.Color.itemBorder}
                radius: 15
                Item{
                    id: article_word
                    width: parent.width; height: parent.height / 2
                    anchors{left: parent.left; top:parent.top}
                    Text{
                        color: Const.Color.listTitle
                        font{pointSize: 20; bold: true}

                        horizontalAlignment: Text.AlignLeft
                        verticalAlignment: Text.AlignVCenter

                        width: parent.width - 40; height: parent.height
                        anchors.centerIn: parent
                        text: "正文字体"
                    }
                    Image{
                        anchors{right: parent.right; verticalCenter: parent.verticalCenter}
                        source: "images/cell_right_arraw.png"
                    }

                    PressArea{
                        anchors.fill: parent
                        onClicked: {
                            sizeSetting.open();
                        }
                    }
                }
                Item{
                    id: article_pager
                    width: parent.width; height: parent.height / 2
                    anchors{left: parent.left; top: article_word.bottom}
                    Text{
                        color: Const.Color.listTitle
                        font{pointSize: 20; bold: true}

                        horizontalAlignment: Text.AlignLeft
                        verticalAlignment: Text.AlignVCenter

                        width: parent.width - 40; height: parent.height
                        anchors.centerIn: parent
                        text: "正文翻页功能"
                    }
                    CheckBox{
                        id: pager_check
                        platformStyle: CheckBoxStyle {
                            inverted: false
                        }
                        checked: MemoryUtil.IsPager
                        anchors{right: parent.right; verticalCenter: parent.verticalCenter}
                        onClicked: {
                            console.debug("pager check clicked:"+pager_check.checked);
                            if(pager_check.checked){
                                DBUtil.updatePager("1");
                                MemoryUtil.setPager("1");
                            }else{
                                DBUtil.updatePager("0");
                                MemoryUtil.setPager("0");
                            }
                        }
                    }
                }
            }
        }
    }

    WordSizeRectange{
        id: sizeSetting
        anchors.fill: parent
    }

    function checkAccount(){
        var accounts = DBUtil.getAccount();
        if(accounts.username === undefined || accounts.username === null || accounts.username === ""){
            return false;
        }else{

        return true;
        }
    }
}
