import QtQuick 1.1
import "Const.js" as Const

Rectangle{
    id: settingmenu_cover
    color: Const.Color.rectTrans

    property int status: Const.Status.Closed

    enabled: settingmenu_cover.status === Const.Status.Opened
    MouseArea{
        anchors.fill: parnet
        enabled: settingmenu_cover.status === Const.Status.Opened
        onClicked: {
            settingmenu_cover.close();
        }
    }

    SettingMenu{
        id: setting_menu

        anchors{top: parent.top; right: parent.right; topMargin: 65; rightMargin: 20}

        onFavorated: {
             mainPage.pageStack.push(Qt.resolvedUrl("FavoratePage.qml"));
        }

        onAbouted: {
             mainPage.pageStack.push(Qt.resolvedUrl("AboutPage.qml"));
        }

        onGuided: {
             mainPage.pageStack.push(Qt.resolvedUrl("FavoratePage.qml"));
        }

        onSettinged: {
             mainPage.pageStack.push(Qt.resolvedUrl("SettingPage.qml"));
        }

        onEditColumned: {
             mainPage.pageStack.push(Qt.resolvedUrl("EditColumnPage.qml"));
        }
    }

    function open(){
        settingmenu_cover.status = Const.Status.Opened
    }

    function close(){
        settingmenu_cover.status = Const.Status.Closed
    }
}
