import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const

Rectangle {
    id: container

    width: 480
    height: 88
    color: "transparent"
    z: 10

    property alias name: topText.text
    property string background: "images/top_navigation_background.png"
    property string borderColor: "#82454D"

    signal clicked

//    BorderImage {
//        id: titlebar_back
//        smooth: true
////        horizontalTileMode: BorderImage.Repeat
//        source: container.background
//        width: container.width; height: container.height
//    }

    gradient: Gradient {
        GradientStop { position: 0.0; color: "#9C0000" }
        GradientStop { position: 1; color: "#660202" }
    }
    Item{
        id: titleName
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: parent.top
        width: root.name === "" ? 80 : 160; height: 88

        Image{
            id: netease_logo
            source: "images/navbar_netease.png"
            anchors.left: parent.left; anchors.verticalCenter: parent.verticalCenter
            width: 80; height: 40
        }

        Text{
            id: topText
            anchors.right: parent.right
            anchors.verticalCenter: parent.verticalCenter
            color: "white"
            font.pointSize: Const.FontSize.title
            visible: root.name === "" ? false : true
//            font.bold: true
        }
    }

    Rectangle{
        width: parent.width / 2; height: parent.height / 2
        color: Const.Color.rectTrans
        anchors{top: parent.top; horizontalCenter: parent.horizontalCenter}
        MouseArea{
            anchors.fill: parent
            onClicked: container.clicked();
        }
    }
}
