import QtQuick 1.1
import com.nokia.meego 1.0
import "Const.js" as Const
import "Common.js" as Common
import "Component"
import "Database.js" as DBUtil
import "RunMemory.js" as MemoryUtil

Page {
    id: vote_main

    orientationLock: PageOrientation.LockPortrait

    property bool hasVote: false
    property string currentId
    property string imgUrl
    property string voteQue
    property string voteDate
    property string voteNote
    property int itemTotalNum: 0
    property int itemTotalCount: 0

    property int flickX: 0
    property int currentIndex: 0

    onStatusChanged: {
        if(PageStatus.Active === vote_main.status){
            // relashed page
//            if(MemoryUtil.reflashable === true && MemoryUtil.reflashPage === "votes"){
//                changePage(vote_main.currentIndex);
//            }
//            MemoryUtil.reflashPage = "";
//            MemoryUtil.reflashable = false;
        }
    }

    TopBackGround{
        id: top_bar
        anchors{left: parent.left; top: parent.top}
        name: "投票"


        ReloadButton{
            id: reload_rect
            width: parent.height; height: parent.height
//            color: Const.Color.rectTrans
            anchors{left: parent.left; top: parent.top}

            onClicked: {
                loading.open();
                  changePage(vote_main.currentIndex);
//                    mainPage.pageStack.push(Qt.resolvedUrl("InfoMainPage.qml"),{reflashPage: "news"});
            }
//            }
        }

        Rectangle{
            id: setting_rect
            width: parent.height; height: parent.height
            color: Const.Color.rectTrans
            anchors{right: parent.right; top: parent.top}

            Item{
                id: setting_btn
                width: 55; height: 55
                anchors.centerIn: parent
                Image{
                    source: "images/setting.png"
                    anchors.fill: parent
                }
            }
            MouseArea{
                anchors.fill: parent

                onClicked: {
                    mainPage.pageStack.push(Qt.resolvedUrl("InfoMainPage.qml"),{reflashPage: "votes"});
                }
            }
        }

    }

    ListModel{
        id: vote_model
    }

    Rectangle{
        id: vote_rect
        width: parent.width; height: parent.height - top_bar.height
        gradient: Gradient {
            GradientStop { position: 0.0; color: Const.Color.backgroundTop }
            GradientStop { position: 1; color: Const.Color.backgroundBottom }
        }
        anchors{left: parent.left; top: top_bar.bottom}

        Flickable{
            anchors.fill: parent
            flickableDirection: Flickable.HorizontalFlick
            contentWidth: parent.width
            contentHeight: parent.height
            pressDelay: 200

            onFlickStarted: {
                console.debug("flick start x:"+contentX)
                vote_main.flickX = contentX;
            }

            onFlickEnded: {
                console.debug("flick end x:"+contentX)
                if(!votePage.visible && !voteResult.visible){
                if(vote_main.flickX < contentX){

                    console.debug("flick left to right");
                    if(vote_main.currentIndex > 0){
                        changePage(vote_main.currentIndex - 1);
                    }else{
                        infoShow.open("当前已经是第一个");
                    }
                }else{
                    console.debug("flick right to left");
                    if(vote_main.currentIndex < (vote_model.count - 1)){
                        changePage(vote_main.currentIndex + 1);
                    }else{
                        infoShow.open("当前已经是最后一个");
                    }
                }
                vote_main.flickX = contentX;
                }
            }
        }

        Item{
            id: img_item
            width: parent.width; height: parent.width * 17 / 32
            anchors{left: parent.left; top: parent.top}
            Image{
                id: img_source
                anchors.fill: parent
                source: vote_main.imgUrl
            }

            Item{
                width: parent.width; height: img_info.height + 30
                anchors{left: parent.left; bottom: parent.bottom}


                Rectangle{
                    color: "black"
                    anchors.fill: parent
                    opacity: 0.5
                    border{color: "#828282"; width: 1}
                }

                Text{
                    id: img_info
                    color: "white"
                    width: parent.width - 30
                    anchors{horizontalCenter: parent.horizontalCenter; top: parent.top; topMargin: 15}
                    font{pointSize: 18}

                    wrapMode: Text.WordWrap
                    text: vote_main.voteNote

                }

            }
        }

        PageIndicator{
           id: vote_pager
           anchors{horizontalCenter: parent.horizontalCenter; top: img_item.bottom}
           width: parent.width - 30; height: 50
           count: vote_model.count
           currentIndex: 0
       }

        Item{
            id: vote_title
            width: parent.width - 30; height: 50
            anchors{horizontalCenter: parent.horizontalCenter; top: vote_pager.bottom}

            Image{
                id: title_img
                anchors{left: parent.left; verticalCenter: parent.verticalCenter}
                source: "images/vote_title.png"
                width: 18; height: 18
            }

            Text{
                width: parent.width - title_img.width - 20; height: parent.height
                anchors{left: title_img.right; leftMargin: 20; verticalCenter: parent.verticalCenter}
                color: "#272727"
                font{pointSize: 20}

                text: "投票问题"

                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter
            }

        }

        Item{
            id: vote_info
            width: parent.width - 30; height: text_title.height + 20;
            anchors{horizontalCenter: parent.horizontalCenter; top: vote_title.bottom}
            Text{
                id: text_title
                width: parent.width
                anchors.centerIn: parent
                color: "#272727"
                font{pointSize: 20}

                horizontalAlignment: Text.AlignLeft

                wrapMode: Text.WordWrap

                text: vote_main.voteQue
            }

        }
        Item{
            id: vote_com
            anchors{top: vote_info.bottom; horizontalCenter: parent.horizontalCenter}
            width: parent.width - 30; height: 50
            Text{
                id: vote_status
                anchors{left: parent.left; verticalCenter: parent.verticalCenter}
                color: "#707070"
                font{pointSize: 17}
                text: vote_main.hasVote ? "投票进行中，看看大家的态度!" : "投票已经结束，看看大家的态度!"

                horizontalAlignment: Text.AlignLeft
                verticalAlignment: Text.AlignVCenter
            }
            Text{
                id: vote_date
                anchors{right: parent.right; verticalCenter: parent.verticalCenter}
                color: "#707070"
                font{pointSize: 17}

                horizontalAlignment: Text.AlignRight
                verticalAlignment: Text.AlignVCenter

                text: vote_main.voteDate
            }
        }


        Item{
            id: vote_btn
            width: parent.width - 30; height: 80
            anchors{horizontalCenter: parent.horizontalCenter; top: vote_com.bottom}
            Rectangle{
            color: Const.Color.rectTrans
        Row{
            anchors.fill: parent
            Image{
                id: left_img
                width: 8; height: parent.height
                source: "images/button2_left.png"
            }

            Image {
                id: middle_img
                width: parent.width - left_img.width - right_img.width; height: parent.height
                source: "images/button2_mid.png"

            }
            Image{
                id: right_img
                width: 8; height: parent.height
                source: "images/button2_right.png"
            }
        }
                width: parent.width * 3 / 4; height: parent.height * 3 / 4
                anchors.centerIn: parent

                Text{
                    anchors.fill: parent
                    color: "#FFFFFF"
                    font{pointSize: 20}
                    text: vote_main.hasVote ? "投票" : "查看结果"

                    horizontalAlignment: Text.AlignHCenter
                    verticalAlignment: Text.AlignVCenter
                }

                PressArea{
                    anchors.fill: parent
                    pressRadius: 10
                    onClicked: {
                        console.debug("vote btn on");
                        voteBtnOn();
                    }
                }
            }
        }




    }

    ListModel{
        id: voteItemModel
    }

    BusyLoading{
        id: loading
        anchors.centerIn: parent
    }

    InfoShow{
        id: infoShow
        anchors{bottom: parent.bottom; bottomMargin: 50}
    }

    VotePage{
        id: votePage
        model: voteItemModel
        buttonModel: voteItemModel
        total: vote_main.itemTotalNum
        voteId: vote_main.currentId
        itemQue: vote_main.voteQue
        anchors.fill: parent

        onVoted: {
            console.debug("vote success");
            DBUtil.addVote(vote_main.currentId);
            vote_main.hasVote = false;
            infoShow.open("投票成功");
            voteResult.open("感谢您的投票");
        }
    }

    VoteResult{
        id: voteResult
        total: vote_main.itemTotalNum
        model: voteItemModel
        voteId: vote_main.currentId
        itemQue: vote_main.voteQue
        anchors.fill: parent
    }

    Component.onCompleted: {
        loading.open();
        changePage(vote_main.currentIndex);
    }

    function getVoteList(){
        initPageItem();

        vote_main.currentIndex = 0;

        Common.getStringByUrl("GET", "http://c.3g.163.com/nokia/nc/vote/init/list.html", voteListCallback);
    }

    function voteListCallback(responseText){
        var obj = JSON.parse(responseText);
        createPageItem(obj);
        var voteList = obj.voteidlist;
        vote_model.clear();
        for(var i in voteList){
            var isFirst = false;
            if(parseInt(i) === 0){
                isFirst = true;
            }
            vote_model.append({
                                  "voteId":voteList[i],
                                  "isFirstItem": isFirst
                              });
        }
        vote_pager.count = vote_model.count;
        console.debug("vote_model count:"+vote_model.count);
        var voteItem = obj.voteitem;
        createVoteItem(voteItem);
        vote_main.currentId = vote_model.get(0).voteId;
        vote_main.hasVote = !DBUtil.isVoted(vote_main.currentId);
        loading.close();
    }

    function createPageItem(obj){
        vote_main.imgUrl = obj.imgsrc;
        vote_main.voteDate = obj.date;
        vote_main.voteNote = obj.digest;
        vote_main.voteQue = obj.question;
    }

    function createVoteItem(obj){
        voteItemModel.clear();
        for(var k in obj){
            var _ite = obj[k];
            vote_main.itemTotalNum += parseInt(_ite.num);
            vote_main.itemTotalCount++;
        }

        for(var i in obj){
            var _item = obj[i];
            voteItemModel.append({
                                     "itemId": _item.id,
                                     "itemNum": _item.num,
                                     "itemName": _item.name,
                                     "itemCount": vote_main.itemTotalCount,
                                     "itemTNum": vote_main.itemTotalNum

                                 });
        }
    }


    function changePage(index){
        MemoryUtil.initProgress();
        if(index === 0){
            getVoteList();
        }else{
            if(vote_model.count > index){
                loading.open();
                initPageItem();
                vote_main.hasVote = false;
                vote_main.currentId = vote_model.get(index).voteId;
                Common.getStringByUrl("GET","http://c.3g.163.com/nokia/nc/vote/result/"+vote_model.get(index).voteId+".html", hasVoteCallback);
            }
        }
        vote_pager.setCurrent(index);
        vote_main.currentIndex = index;
    }

    function hasVoteCallback(responseText){
        var obj = JSON.parse(responseText);
        createPageItem(obj);
        var voteItem = obj.voteitem;
        createVoteItem(voteItem);
        loading.close();
    }

    function initPageItem(){
        console.debug("init page");
        voteItemModel.clear();
        vote_main.itemTotalNum = 0;
        vote_main.itemTotalCount = 0;
        vote_main.imgUrl = "";
        vote_main.voteDate = "";
        vote_main.voteNote = "";
        vote_main.voteQue = "";
    }

    function voteBtnOn(){
        if(vote_main.hasVote){
            votePage.open();
        }else{
            voteResult.open("投票已结束");
        }
    }
}
